您的位置:首页 > 其它

POJ - 3126 Prime Path

2018-03-13 20:49 369 查看
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179 The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased. Input One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros). Output One line for each case, either with a number stating the minimal cost or containing the word Impossible. Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0


问从a到b需要经过几步变换,变换规则为,只能变成素数,并且只有一位数字变换
#include <iostream>
#include <queue>
#include<algorithm>
#include<stdio.h>
#include<string.h>

using namespace std;
#define MAXV 10000

bool prime[MAXV];

void init(){
int i,j;
for(i=1000;i<=MAXV;i++){
for(j=2;j<i;j++)
if(i%j==0){
prime[i]=false;
break;
}
if(j==i) prime[i]=true;
}
}

int bfs(int first,int last){
bool dis[MAXV];
queue <int>q;
int v,i,j,temp,vtemp,count[MAXV],t[4];
memset(dis,false,sizeof(dis));
memset(count,0,sizeof(count));

q.push(first);
dis[first]=true;

while(!q.empty()){
v=q.front();
q.pop();

t[0]=v/1000;
t[1]=v%1000/100;
t[2]=v%100/10;
t[3]=v%10;
for(j=0;j<4;j++){
temp=t[j];
for(i=0;i<10;i++)
if(i!=temp){
t[j]=i;
vtemp=t[0]*1000+t[1]*100+t[2]*10+t[3];
if(!dis[vtemp] && prime[vtemp]){
count[vtemp]=count[v]+1;
dis[vtemp]=true;
q.push(vtemp);
}
if(vtemp==last) return count[vtemp];
}
t[j]=temp;
}
if(v==last) return count[v];
}
return -1;
}

int main(){
int n,a,b,key;
init();
scanf("%d",&n);
while(n--){
scanf("%d%d",&a,&b);
key=bfs(a,b);
if(key!=-1) printf("%d\n",key);
else printf("Impossible\n");
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: